"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var wait_1 = require("./wait");
var Executor = (function () {
    function Executor(main, options) {
        this.main = main;
        this.options = options;
        this.maxTries = Executor.defaultMaxTries;
        this.retryCondition = Executor.defaultRetryCondition;
        this.waiter = Executor.defaultWaiter;
        if (options) {
            if (options.maxTries)
                this.maxTries = options.maxTries;
            if (options.retryCondition)
                this.retryCondition = options.retryCondition;
            if (options.waiter)
                this.waiter = options.waiter;
            if (options.beforeTry)
                this.beforeTry = options.beforeTry;
            if (options.afterTry)
                this.afterTry = options.afterTry;
            if (options.beforeWait)
                this.beforeWait = options.beforeWait;
            if (options.afterWait)
                this.afterWait = options.afterWait;
            if (options.doFinally)
                this.doFinally = options.doFinally;
        }
    }
    Executor.prototype.execute = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var successful, result, tries, reason_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        successful = false;
                        result = undefined;
                        tries = 1;
                        _b.label = 1;
                    case 1:
                        if (!(tries <= this.maxTries)) return [3 /*break*/, 20];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 8, , 19]);
                        if (!this.beforeTry) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.beforeTry(tries, result)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [4 /*yield*/, this.main.apply(this, args)];
                    case 5:
                        result = _b.sent();
                        successful = true;
                        if (!this.afterTry) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.afterTry(tries, result)];
                    case 6:
                        _b.sent();
                        _b.label = 7;
                    case 7: return [3 /*break*/, 20];
                    case 8:
                        reason_1 = _b.sent();
                        result = reason_1;
                        if (!this.afterTry) return [3 /*break*/, 10];
                        return [4 /*yield*/, this.afterTry(tries, result)];
                    case 9:
                        _b.sent();
                        _b.label = 10;
                    case 10:
                        _a = tries === this.maxTries;
                        if (_a) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.retryCondition(tries, result)];
                    case 11:
                        _a = !(_b.sent());
                        _b.label = 12;
                    case 12:
                        if (_a)
                            return [3 /*break*/, 20];
                        if (!this.beforeWait) return [3 /*break*/, 14];
                        return [4 /*yield*/, this.beforeWait(tries, result)];
                    case 13:
                        _b.sent();
                        _b.label = 14;
                    case 14:
                        if (!this.waiter) return [3 /*break*/, 16];
                        return [4 /*yield*/, this.waiter(tries, result)];
                    case 15:
                        _b.sent();
                        _b.label = 16;
                    case 16:
                        if (!this.afterWait) return [3 /*break*/, 18];
                        return [4 /*yield*/, this.afterWait(tries, result)];
                    case 17:
                        _b.sent();
                        _b.label = 18;
                    case 18: return [3 /*break*/, 19];
                    case 19:
                        tries++;
                        return [3 /*break*/, 1];
                    case 20:
                        if (!this.doFinally) return [3 /*break*/, 22];
                        return [4 /*yield*/, this.doFinally()];
                    case 21:
                        _b.sent();
                        _b.label = 22;
                    case 22:
                        if (successful) {
                            return [2 /*return*/, result];
                        }
                        else {
                            throw result;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return Executor;
}());
Executor.defaultMaxTries = 5;
Executor.defaultRetryCondition = function () { return true; };
Executor.defaultWaiter = function (tries) { return wait_1.default(100 * Math.pow(tries, 2)); };
exports.Executor = Executor;
exports.default = Executor;
//# sourceMappingURL=executor.js.map